#---------------------------------------------------------
# This Datapack was made by CommandGeek
# Please do not copy or credit this as your own work!
# Youtube: www.youtube.com/CommandGeek
#---------------------------------------------------------

# For all "a house"

execute as @e[name="a house"] store result score @s EvilHouseMotionX run data get entity @s Motion[0] 1000
execute as @e[name="a house"] store result score @s EvilHouseMotionZ run data get entity @s Motion[2] 1000

execute as @e[name="a house"] run data modify entity @s Rotation[1] set value 0.0f

scoreboard players add @e[tag=walk,scores={EvilHouseWalk=0}] EvilHouseWalking 1
scoreboard players remove @e[tag=walk,scores={EvilHouseWalk=1}] EvilHouseWalking 1
scoreboard players set @e[scores={EvilHouseWalking=10..}] EvilHouseWalk 1
scoreboard players set @e[scores={EvilHouseWalking=..-10}] EvilHouseWalk 0
scoreboard players set @e[name=evil_house_body,tag=!walk] EvilHouseWalking 0
scoreboard players set @e[name=evil_house_legs,tag=!walk] EvilHouseWalking 0

execute as @e[name=evil_house_legs] store result entity @s Pose.LeftArm[0] float 6 run scoreboard players get @s EvilHouseWalking
execute as @e[name=evil_house_legs] store result entity @s Pose.RightArm[0] float -6 run scoreboard players get @s EvilHouseWalking
execute as @e[name=evil_house_body] store result entity @s Pose.RightArm[0] float 6 run scoreboard players get @s EvilHouseWalking
execute as @e[name=evil_house_body] store result entity @s Pose.LeftArm[0] float -6 run scoreboard players get @s EvilHouseWalking

execute at @e[scores={EvilHouseWalking=10}] run playsound minecraft:entity.zombie.attack_wooden_door master @a ~ ~ ~ 1 0
execute at @e[scores={EvilHouseWalking=-10}] run playsound minecraft:entity.zombie.attack_wooden_door master @a ~ ~ ~ 1 0

# Death


execute at @e[scores={EvilHouseWalking=-10}] run function evil_house:damage
execute at @e[scores={EvilHouseWalking=10}] run function evil_house:damage

    
effect give @e[name="a house"] invisibility 1 1 true
effect give @e[name=evil_house_hitbox] invisibility 1 1 true


# functinos for evil_house_body

execute as @e[name=evil_house_body] at @e[name="a house"] if score @s EvilHouseID = @e[name="a house",distance=0,limit=1] EvilHouseID run function evil_house:evil_house_body
    
execute as @e[name=evil_house_legs] at @e[name="a house"] if score @s EvilHouseID = @e[name="a house",distance=0,limit=1] EvilHouseID run function evil_house:evil_house_legs
    
execute as @e[name=evil_house_hitbox] at @e[name="a house"] if score @s EvilHouseID = @e[name="a house",distance=0,limit=1] EvilHouseID run function evil_house:evil_house_hitbox



# Kill House

execute as @e[name=evil_house_hitbox] store result score @s EvilHouseHealth run data get entity @s Health
execute as @e[name=evil_house_hitbox] at @s unless score @s EvilHouseHealth = @s EvilHouseHealth2 as @e[name=evil_house_body] if score @s EvilHouseID = @e[name=evil_house_hitbox,distance=0,limit=1] EvilHouseID run scoreboard players set @s EvilHouseDamage 8
execute as @e[name=evil_house_hitbox] store result score @s EvilHouseHealth2 run data get entity @s Health

execute as @e[tag=evil_house] at @e[name=evil_house_hitbox,scores={EvilHouseHealth=..750}] if score @s EvilHouseID = @e[name=evil_house_hitbox,distance=0,limit=1] EvilHouseID run function evil_house:evil_house_kill

# Spawn House

execute as @a[scores={EvilHouseOak=1..}] at @s run function evil_house:spawn_house
execute as @a[scores={EvilHouseSpruce=1..}] at @s run function evil_house:spawn_house
execute as @a[scores={EvilHouseBirch=1..}] at @s run function evil_house:spawn_house
execute as @a[scores={EvilHouseJungle=1..}] at @s run function evil_house:spawn_house
execute as @a[scores={EvilHouseAcacia=1..}] at @s run function evil_house:spawn_house
execute as @a[scores={EvilHouseDarkOak=1..}] at @s run function evil_house:spawn_house


scoreboard players set @a EvilHouseOak 0
scoreboard players set @a EvilHouseSpruce 0
scoreboard players set @a EvilHouseBirch 0
scoreboard players set @a EvilHouseJungle 0
scoreboard players set @a EvilHouseAcacia 0
scoreboard players set @a EvilHouseDarkOak 0


scoreboard players set @e[name=evil_house_body,tag=new] EvilHouseWalk 0
scoreboard players set @e[name=evil_house_legs,tag=new] EvilHouseWalk 0

execute as @e[tag=new] run data merge entity @s {Rotation:[0.0f,0.0f]}
execute as @e[name="a house",tag=new] store result score @s EvilHouseID run function evil_house:house_id
execute as @e[name="a house",tag=new] run scoreboard players operation @e[tag=new,limit=4] EvilHouseID = @s EvilHouseID
execute as @e[name="a house",tag=new] at @s run tp @s ~ ~3 ~
execute as @e[name="a house",tag=new] run data merge entity @s {Motion:[0.0d,-10.0d,0.0d]}
execute as @e[name="a house",tag=new] at @s run tp @s ~ ~ ~ facing entity @p
execute as @e[name="a house",tag=new] at @s run function evil_house:activate_effects
tag @e[tag=new] remove new
    
execute as @e[name="a house"] store result score @s HouseRotation run data get entity @s Rotation[0]


# execute at @e[name="a house"] run particle smoke ~ ~ ~ .5 1 .5 0 10

# MISC

execute as @e[name=evil_house_hitbox,nbt=!{Size:11}] at @s run tp @s ~ -200 ~


execute store result score doTileDrops EvilHouseSuccess run gamerule doTileDrops
gamerule doTileDrops false
execute at @e[name="a house"] run fill ~3 ~8 ~3 ~-3 ~1 ~-3 air destroy
execute if score doTileDrops EvilHouseSuccess matches 1 run gamerule doTileDrops true

team join EvilHouse @e[tag=evil_house,name=!evil_house_hitbox,team=!EvilHouse]

# Evil House Damage


replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=1..}] armor.head oak_door{CustomModelData:203}
replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=0}] armor.head oak_door{CustomModelData:202}

replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=1..}] weapon.mainhand oak_door{CustomModelData:213}
replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=1..}] weapon.offhand oak_door{CustomModelData:213}
replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=0}] weapon.mainhand oak_door{CustomModelData:212}
replaceitem entity @e[name=evil_house_body,scores={EvilHouseDamage=0}] weapon.offhand oak_door{CustomModelData:212}


execute as @e[name=evil_house_legs] at @e[name=evil_house_body,scores={EvilHouseDamage=1..}] if score @s EvilHouseID = @e[name=evil_house_body,distance=0,limit=1] EvilHouseID run replaceitem entity @s weapon.mainhand oak_door{CustomModelData:223}
execute as @e[name=evil_house_legs] at @e[name=evil_house_body,scores={EvilHouseDamage=1..}] if score @s EvilHouseID = @e[name=evil_house_body,distance=0,limit=1] EvilHouseID run replaceitem entity @s weapon.offhand oak_door{CustomModelData:223}
execute as @e[name=evil_house_legs] at @e[name=evil_house_body,scores={EvilHouseDamage=0}] if score @s EvilHouseID = @e[name=evil_house_body,distance=0,limit=1] EvilHouseID run replaceitem entity @s weapon.mainhand oak_door{CustomModelData:222}
execute as @e[name=evil_house_legs] at @e[name=evil_house_body,scores={EvilHouseDamage=0}] if score @s EvilHouseID = @e[name=evil_house_body,distance=0,limit=1] EvilHouseID run replaceitem entity @s weapon.offhand oak_door{CustomModelData:222}


execute at @e[name=evil_house_body,scores={EvilHouseDamage=7}] run particle minecraft:damage_indicator ~ ~2 ~ 1.2 1.2 1.2 0.1 100

# execute at @e[name=evil_house_body,scores={EvilHouseDamage=7}] run playsound minecraft:entity.zombie.break_wooden_door master @a ~ ~ ~ 1

scoreboard players remove @e[name=evil_house_body,scores={EvilHouseDamage=1..}] EvilHouseDamage 1



# Spawning

execute unless score Count EvilHouseSuccess matches 10.. as @a[gamemode=!creative,gamemode=!spectator] at @s if block ~ ~ ~ oak_door rotated 0 0 run function evil_house:detect_house
execute unless score Count EvilHouseSuccess matches 10.. as @a[gamemode=!creative,gamemode=!spectator] at @s if block ~ ~ ~ oak_door rotated 90 0 run function evil_house:detect_house
execute unless score Count EvilHouseSuccess matches 10.. as @a[gamemode=!creative,gamemode=!spectator] at @s if block ~ ~ ~ oak_door rotated 180 0 run function evil_house:detect_house
execute unless score Count EvilHouseSuccess matches 10.. as @a[gamemode=!creative,gamemode=!spectator] at @s if block ~ ~ ~ oak_door rotated 270 0 run function evil_house:detect_house

execute store result score Count EvilHouseSuccess run execute if entity @e[name="a house",tag=evil_house]
